Subject: Re: linux-next: build failure after merge of the final tree (hid tree related)

From: Bruno Prémont <[email-masked]>
Date: Thu, 1 Apr 2010 21:05:19 +0200

On Thu, 01 April 2010 Bruno Prémont <[email-masked]> wrote:
> Hi Jiri, Stephen,
> 
> Wondering why x86 (32bit and 64bit) does not need to include the
> header but other arches (at least powerpc) need it.
> 
> Any idea via which header linux/uaccess.h gets included on x86?
> If nobody has checked by the time I get home I will determine that.

Here is the include path for x86:
included arch/x86/include/asm/uaccess.h
    from arch/x86/include/asm/sections.h:5,
    from arch/x86/include/asm/hw_irq.h:26,
    from include/linux/irq.h:233,
    from arch/x86/include/asm/hardirq.h:5,
    from include/linux/hardirq.h:10,
    from include/linux/interrupt.h:12,
    from include/linux/usb.h:15,
    from drivers/hid/hid-picolcd.c:26:

Wondering why there is such a difference for powerpc!

Thanks,
Bruno

> On Thu, 1 Apr 2010 18:35:30 Stephen Rothwell wrote:
> > Hi Jiri,
> > 
> > On Thu, 1 Apr 2010 08:18:43 +0200 (CEST) Jiri Kosina
> > <[email-masked]> wrote:
> > >
> > > On Thu, 1 Apr 2010, Stephen Rothwell wrote:
> > > 
> > > > After merging the final tree, today's linux-next build (powerpc
> > > > allyesconfig) failed like this:
> > > > 
> > > > drivers/hid/hid-picolcd.c: In function
> > > > 'picolcd_debug_reset_write': drivers/hid/hid-picolcd.c:1343:
> > > > error: implicit declaration of function 'copy_from_user'
> > > > drivers/hid/hid-picolcd.c: In function
> > > > 'picolcd_debug_eeprom_read': drivers/hid/hid-picolcd.c:1407:
> > > > error: implicit declaration of function 'copy_to_user'
> > > > 
> > > > Caused by commit 9bbf2b98ba11d00bd73e3254e15cfe17ccaff6ba ("HID:
> > > > add experimental access to PicoLCD device's EEPROM and FLASH").
> > > > Using copy_ {to,from}_user requires the include of
> > > > linux/uaccess.h.
> > > > 
> > > > I have reverted that commit for today.
> > > 
> > > Hmm, on which arch did this bomb out? I wonder why it is building
> > > fine for me.
> > 
> > PowerPC (see above).  It could also be some interaction with another
> > tree in linux-next.
> > 
> > > Anyway, I have added the include, as it is obviously correct(tm),
> > > thanks for reporting it.
> > 
> > Thanks.
> >